import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrClassroomcoursequestion {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  ClassRoomCourseId!: IType<number, bigint>;
  Name?: string;
  KnowledgepointIds?: any;
  Use!: number;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const IcrClassroomcoursequestionSchema = defineEntity({
  class: IcrClassroomcoursequestion,
  comment: '课堂问题',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    ClassRoomCourseId: p.bigint().name('ClassRoomCourseId').columnType('bigint').comment('课堂课程Id'),
    Name: p.string().name('Name').nullable().comment('课堂课程问题名称'),
    KnowledgepointIds: p.json().name('KnowledgepointIds').nullable().comment('关联的知识点ids'),
    Use: p.integer().name('Use').comment('0-未使用 1-使用'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
